<template>
	<div :class="[$style.review, $style[review.details.product_page_id]]">
		<GlobalEvents v-if="showIcon" target="window" @resize="setIconPosition" />

		<div :class="$style.reviewLeft">
			<p v-if="review.details.nickname" :class="$style.author">
				{{ review.details.nickname }}
			</p>

			<div v-if="review.metrics.rating" :class="$style.rating">
				<AtomReviewStars :rating="review.metrics.rating" />
			</div>

			<div :class="$style.meta">
				<p v-if="review.details.location">
					{{ review.details.location }}
				</p>

				<p v-if="review.details.created_date">
					{{ review.details.created_date | formatDate }}
				</p>
			</div>
		</div>

		<div ref="content" :class="$style.reviewRight">
			<div :class="$style.details">
				<div :class="$style.content">
					<div v-if="showIcon" ref="iconSpacer" :class="$style.iconSpacer"></div>
					<div v-if="showIcon" ref="iconContent" :class="$style.iconContent">
						<BaseImage
							v-if="icons[review.details.product_page_id]"
							v-bind="icons[review.details.product_page_id]"
							:alt="review.details.product_page_id"
							sizes="40px"
						/>
					</div>

					<h2 v-if="review.details.headline" class="u-font-secondary" :class="$style.title">
						{{ review.details.headline }}
					</h2>

					<p v-if="comments" :class="$style.comments">
						{{ comments }}
					</p>
				</div>

				<div v-if="hasImage" :class="$style.image">
					<img :src="review.media[0].uri" :alt="review.media[0].caption" />
				</div>
			</div>

			<button v-if="showCommentsExcerpt" type="button" :class="$style.url" @click="toggleExcerpt('comments')">
				{{ isCommentsFull ? 'View Less' : 'Continue Reading' }}
			</button>

			<div v-if="response" :class="$style.response">
				<h2 class="u-font-secondary" :class="$style.title"> Molekule </h2>

				<p :class="$style.comments">
					{{ response }}
				</p>

				<button v-if="showResponseExcerpt" type="button" :class="$style.url" @click="toggleExcerpt('response')">
					{{ isResponseFull ? 'View Less' : 'Continue Reading' }}
				</button>
			</div>
		</div>
	</div>
</template>

<script>
import AtomReviewStars from '@components/atom-review-stars';
import molekuleIcon from '~/assets/images/review-molekule.svg';
import minimoIcon from '~/assets/images/review-minimo.svg';

export default {
	components: {
		AtomReviewStars,
	},

	props: {
		review: {
			type: Object,
			default: () => ({}),
		},
	},

	data: () => ({
		isCommentsFull: false,
		isResponseFull: false,
		excerptLength: 260,
	}),

	computed: {
		icons() {
			return {
				molekule: { image: molekuleIcon, aspect: 31 / 77 },
				'molekule-air': { image: molekuleIcon, aspect: 31 / 77 },
				minimo: { image: minimoIcon, aspect: 39 / 54 },
				'molekule-air-mini': { image: minimoIcon, aspect: 39 / 54 },
			};
		},

		hasImage() {
			return Boolean(this.review.media.length && this.review.media[0].type === 'image');
		},

		showIcon() {
			return !this.hasImage && !this.response;
		},

		showCommentsExcerpt() {
			if (!this.review.details.comments) return false;

			return this.review.details.comments.length > this.excerptLength;
		},

		showResponseExcerpt() {
			if (!this.review.details.merchant_response) return false;

			return this.review.details.merchant_response.length > this.excerptLength;
		},

		comments() {
			const comments = this.review.details.comments;

			if (!comments) return false;

			return this.showCommentsExcerpt && !this.isCommentsFull
				? this.$options.filters.truncate(comments, this.excerptLength)
				: comments;
		},

		response() {
			const response = this.review.details.merchant_response;

			if (!response) return false;

			return this.showResponseExcerpt && !this.isResponseFull
				? this.$options.filters.truncate(response, this.excerptLength)
				: response;
		},
	},

	mounted() {
		// this.$nextTick(() => this.$nextTick(this.setIconPosition));
		this.$nextTick(this.setIconPosition);
	},

	methods: {
		setIconPosition() {
			const { content, iconSpacer, iconContent } = this.$refs;
			if (!(content && iconSpacer && iconContent)) return;
			iconSpacer.style.height = '';
			iconContent.style.display = '';
			const contentHeight = content.offsetHeight;
			iconContent.style.top = '10px';
			iconContent.style.display = 'block';
			const iconHeight = iconContent.offsetHeight;
			if (contentHeight < iconHeight) {
				iconContent.style.display = '';
				return;
			}

			const spacerHeight = contentHeight - iconHeight;
			iconSpacer.style.height = `${spacerHeight}px`;
			const contentHeightSecond = content.offsetHeight;
			if (contentHeightSecond > contentHeight) {
				iconContent.style.top = `${10 + (contentHeightSecond - contentHeight)}px`;
			}
		},

		toggleExcerpt(value) {
			value === 'comments'
				? (this.isCommentsFull = !this.isCommentsFull)
				: (this.isResponseFull = !this.isResponseFull);

			if (this.showIcon) {
				this.$nextTick(this.setIconPosition);
			}

			if (this.isCommentsFull) {
				this.$tealiumEvent('reviews_detail', {
					event_category: 'Reviews',
					event_action: 'Clicked Continue Reading',
					event_label: this.review.details.headline,
					event_value: this.review.metrics.rating,
					review_term: this.review.details.headline,
				});
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.review {
	padding: size('s');
	margin-bottom: size('s');
	border: 1px solid color('border');

	@include above('medium') {
		display: flex;
		border-radius: 0.4rem;
	}
}

.reviewLeft {
	@include below('medium') {
		display: flex;
		align-items: center;
		justify-content: space-between;
		margin-bottom: size('s');
	}

	@include above('medium') {
		flex: 0 0 auto;
		width: 17rem;
	}
}

.reviewRight {
	@include above('medium') {
		flex: 1 1 auto;
		width: 0;
	}
}

.author {
	@include use-text-style('type-400');

	@include above('medium') {
		margin-bottom: size('s');
	}
}

.rating {
	@include above('medium') {
		margin-bottom: 5rem;
	}
}

.meta {
	@include use-text-style('type');
	@include use-text-style('type-400');

	color: color('primary-100');

	@include below('medium') {
		display: none;
	}
}

.title {
	@include use-text-style('heading-100');

	margin-bottom: size('xxs');
}

.details {
	@include above('medium') {
		display: flex;
	}
}

.content {
	@include above('medium') {
		flex: 1 1 auto;
	}
}

.iconSpacer {
	float: right;
}

.iconContent {
	position: relative;
	box-sizing: content-box;
	display: none;
	float: right;
	padding-left: 10px;
	margin-bottom: -40px;
	clear: right;

	.review.molekule &,
	.review.molekule-air & {
		width: 31px;
		margin-right: -13px;
	}

	.review.minimo &,
	.review.molekule-air-mini & {
		width: 39px;
		margin: -10px;
	}
}

.comments {
	color: color('primary-100');

	@include use-text-style('type');
	@include use-text-style('type-100');
}

.image {
	margin-top: size('s');

	@include above('medium') {
		flex: 0 0 auto;
		max-width: 14rem;
		margin-top: 0;
		margin-left: size('s');
	}
}

.url {
	display: inline-block;
	margin-top: size('s');

	@include use-text-style('type-100');
}

.response {
	margin-top: size('m');

	@include above('medium') {
		margin-left: 6.5rem;
	}
}
</style>
